(function()
{
	var scripts = document.getElementsByTagName('script'),
		thisScript = scripts[scripts.length - 1],
		data = {title: document.title, url: document.location.href},
		path = (thisScript.src.indexOf('//') != -1) ? ('//' + thisScript.src.split('//')[1].split('/')[0]) : '',
		type = thisScript.getAttribute('data-type'),
		popup = thisScript.getAttribute('data-popup');

	if((type === null || isNaN(type - 0)) && thisScript.src.match(/^.*\?type=(\d).*$/i))
		type = RegExp.$1 - 0;
	type = isNaN(type) ? 1 : Math.max(Math.min(type, 4), 0);

	if(!popup || !(popup in {'left-up': 0, 'right-up': 1, 'left-down': 2, 'right-down': 3}))
		popup = 'left-up';

	if('pip_button' in window)
	{
		data = window.pip_button;
	}
	else
	{
		var title = thisScript.getAttribute('data-title'),
			url = thisScript.getAttribute('data-url');
		if(title !== null)
			data.title = title;
		if(url !== null)
			data.url = url;
	}

	data = {title: encodeURIComponent(data.title), url: encodeURIComponent(data.url)};

	var projects = [
		{name: 'Memori',       link: 'http://memori.qip.ru/link/?sm=1&u_data[url]=' + data.url + '&u_data[name]=' + data.title},
		{name: 'БобрДобр',     link: 'http://bobrdobr.ru/addext.html?url=' + data.url + '&title=' + data.title},
		{name: 'Google',       link: 'http://www.google.com/bookmarks/mark?op=add&bkmk=' + data.url + '&title=' + data.title},
		{name: 'Яндекс',       link: 'http://zakladki.yandex.ru/newlink.xml?url=' + data.url + '&name=' + data.title},
		{name: 'Twitter',      link: 'http://twitter.com/intent/tweet?text=' + data.title + '&url=' + data.url},
		{name: 'Delicious',    link: 'http://del.icio.us/post?v=4&noui&jump=close&url=' + data.url + '&title=' + data.title},
		{name: 'Yahoo!',       link: 'http://myweb2.search.yahoo.com/myresults/bookmarklet?u=' + data.url + '&t=' + data.title},
		{name: 'Facebook',     link: 'http://www.facebook.com/share.php?u=' + data.url + '&t=' + data.title},
		{name: 'LiveJournal',  link: 'http://www.livejournal.com/update.bml?subject=' + data.title + '&event=%3Ca+href%3D%22' + data.url + '%22%3E' + data.title + '%3C%2Fa%3E%0A%0A'},
		{name: 'News 2',       link: 'http://news2.ru/add_story.php?url=' + data.url},
		{name: 'MySpace',      link: 'http://www.myspace.com/Modules/PostTo/Pages/?u=' + data.url},
		{name: 'Мистер Вонг',  link: 'http://www.mister-wong.ru/index.php?action=addurl&bm_url=' + data.url + '&bm_description=' + data.title},
		{name: 'Моё Место',    link: 'http://moemesto.ru/post.php?url=' + data.url + '&title=' + data.title},
		{name: 'СМИ 2',        link: 'http://smi2.ru/add/?url=' + data.url + '&precaption=' + data.title},
		{name: 'Baay!',        link: 'http://www.vaau.ru/submit/?action=step2&url=' + data.url},
		{name: 'RuSpace',      link: 'http://www.ruspace.ru/index.php?link=bookmark&action=bookmarkNew&bm=1&url=' + data.url + '&title=' + data.title},
		{name: 'Сто закладок', link: 'http://www.100zakladok.ru/save/?bmurl=' + data.url + '&bmtitle=' + data.title},
		{name: 'Мблоги',       link: 'http://mblogi.qip.ru/knopka/?url=' + data.url + '&title=' + data.title},
		{name: 'Surfingbird',  link: 'http://surfingbird.ru/share?url=' + data.url},
		{name: 'Вконтакте',    link: 'http://vk.com/share.php?url=' + data.url},
		{name: 'Mail.ru',      link: 'http://connect.mail.ru/share?share_url=' + data.url},
		{name: 'Одноклассники',link: 'http://ok.ru/dk?st.cmd=addShare&st.s=1&st._surl=' + data.url}
	];

	var $$ = function(tagName, attributes, styles, childs)
	{
		var element = document.createElement(tagName);
		if(attributes) for(var property in attributes) element[property] = attributes[property];
		if(styles) for(var property in styles) element.style[property] = styles[property];
		if(childs) for(var i = 0; i < childs.length; i++) element.appendChild(childs[i]);
		return element;
	};

	if(!document.getElementById('pip_button_stylesheet'))
	{
		document.getElementsByTagName('head')[0].appendChild($$('div', {innerHTML: 'a<style type="text/css" id="pip_button_stylesheet">.pip_container{position:relative} .pip_type0{width:423px} .pip_type1{width:239px} .pip_type2{width:248px} .pip_type3{width:173px} .pip_type4{width:128px} .pip_bg{overflow:hidden;background:transparent url(' + path + '/i/pip/button.png?1) -1000px -1000px no-repeat} .pip_container .pip_btn a, .pip_container .pip_btn span, .pip_container .pip_btn .pip_hover{display:block;float:left;margin:0} .pip_type0 .pip_btn{padding:2px 0 3px 0;width:422px;height:44px;background:transparent url(' + path + '/i/pip/bookmark.png) left top no-repeat} .pip_type1 .pip_btn{padding:2px 0 3px 0;width:239px;height:26px;background-position:0 0} .pip_type2 .pip_btn{padding:0;width:248px;height:24px;background-position:0 -35px} .pip_type3 .pip_btn{width:173px;height:20px;background-position:0 -65px} .pip_type4 .pip_btn{width:128px;height:16px;background-position:0 -91px} .pip_type0 .pip_btn a{margin:6px 4px 6px 0;width:32px;height:32px} .pip_type1 .pip_btn a{margin:4px 3px 4px 0;width:18px;height:18px} .pip_type2 .pip_btn a{margin:0 1px 0 0;width:24px;height:24px} .pip_type3 .pip_btn a{margin:0 4px 0 0;width:20px;height:20px} .pip_type0 .pip_btn .pip_plus{margin:0 0 0 3px;width:43px;height:43px} .pip_type0 .pip_btn .pip_space{width:170px;height:43px} .pip_type0 .pip_btn .pip_hover{margin:0 0 0 3px;width:22px;height:44px;background:none} .pip_type0 .pip_btn .pip_hover:hover{background:none} .pip_type1 .pip_btn .pip_plus{margin:0 0 0 2px;width:25px;height:25px} .pip_type1 .pip_btn .pip_space{width:93px;height:25px} .pip_type1 .pip_btn .pip_hover{width:14px;height:26px;background-position:-245px -2px} .pip_type1 .pip_btn .pip_hover:hover{background:none} .pip_type2 .pip_btn .pip_plus{margin:0;width:24px;height:24px} .pip_type2 .pip_btn .pip_space{width:85px;height:24px} .pip_type2 .pip_btn .pip_hover{margin:0;width:12px;height:24px} .pip_type3 .pip_btn .pip_hover{width:77px;height:20px} .pip_type4 .pip_btn .pip_hover{width:128px;height:16px} .pip_type3 .pip_btn .pip_plus, .pip_type3 .pip_btn .pip_space, .pip_type4 .pip_btn .pip_plus, .pip_type4 .pip_btn .pip_space{display:none} .pip_popup{position:absolute;z-index:20;padding:5px 0 0 7px;width:255px;height:155px;font:normal 12px/16px Arial;text-align:center;background-color:#fff;border:#d1d3d4 solid 1px;-moz-border-radius:5px;border-radius:5px;-moz-box-shadow:0px 1px 3px 0px rgba(0,0,0,0.15), 0 -170px 200px -100px rgba(0,0,0,0.025) inset;box-shadow:0px 1px 3px 0px rgba(0,0,0,0.15), 0 -170px 200px -100px rgba(0,0,0,0.025) inset} .pip_popup_hidden{display:none} .pip_popup span, .pip_popup a.pip_bg{display:blocks;float:left;margin:0 0 3px;width:85px;height:16px;overflow:hidden;color:#000;text-decoration:none;text-align:left} .pip_popup a.pip_bg{padding-left:19px;width:65px} .pip_popup a.pip_bg:hover{text-decoration:underline} .pip_popup .pip_qip{clear:left;display:block;margin:0 auto;padding-top:3px;width:70px;font:normal normal 11px/16px Arial;color:#027cb2;text-align:center;outline:none} .pip_popup_left-up{right:0;bottom:100%;margin:0 2px 15px 0} .pip_popup_right-up{left:100%;bottom:100%;margin:0 0 15px -14px} .pip_popup_left-down{right:0;top:100%;margin:15px 2px 0 0} .pip_popup_right-down{left:100%;top:100%;margin:15px 0 0 -14px} .pip_popup_corner1, .pip_popup_corner2{position:absolute;width:0;height:0} .pip_popup_corner1{border-top:transparent solid 14px;border-bottom:transparent solid 14px;border-top:rgba(255,255,255,0) solid 14px;border-bottom:rgba(255,255,255,0) solid 14px} .pip_popup_corner2{border-bottom:transparent solid 15px;border-top:transparent solid 15px;border-bottom:rgba(255,255,255,0) solid 15px;border-top:rgba(255,255,255,0) solid 15px} .pip_popup_left-up .pip_popup_corner1{right:-1px;bottom:-15px;border-right:#d1d3d4 solid 14px} .pip_popup_left-up .pip_popup_corner2{right:0;bottom:-13px;border-right:#fafafa solid 15px;border-right:#ffffff solid 15px\0} .pip_popup_right-up .pip_popup_corner1{left:-1px;bottom:-15px;border-left:#d1d3d4 solid 14px} .pip_popup_right-up .pip_popup_corner2{left:0;bottom:-13px;border-left:#fafafa solid 15px;border-left:#ffffff solid 15px\0} .pip_popup_left-down .pip_popup_corner1{right:-1px;top:-15px;border-right:#d1d3d4 solid 14px} .pip_popup_left-down .pip_popup_corner2{right:0;top:-13px;border-right:#ffffff solid 15px} .pip_popup_right-down .pip_popup_corner1{left:-1px;top:-15px;border-left:#d1d3d4 solid 14px} .pip_popup_right-down .pip_popup_corner2{left:0;top:-13px;border-left:#ffffff solid 15px}</style>'}).getElementsByTagName('style')[0]);
	}

	var pip = {hover: null, button: null, popup: null}, links = [
		$$('a', {className: 'pip_plus', href: '//pip.qip.ru/', target: '_blank'}),
		$$('span', {className: 'pip_space'})
	];
	for(var i = 0, items = [[4,19,7,21,20], [4,19,7,21,20], [7,4,21,19,20], [4,7,19,21], []][type]; i < items.length; i++)
		links.push($$('a', {href: projects[items[i]].link, target: '_blank', title: projects[items[i]].name}));
	links.push(pip.hover = $$('a', {className: 'pip_bg pip_hover', href: '//pip.qip.ru/', target: '_blank', onclick: function(){return false}}));
	pip.button = $$('div', {className: 'pip_bg pip_btn', title: 'Поделиться'}, null, links);
	projects = projects.slice(0, -3);

	links = [$$('div', {className: 'pip_popup_corner1'}), $$('div', {className: 'pip_popup_corner2'}), $$('span', {innerHTML: 'Закладки'})];
	for(var i = 0; i < projects.length; i++)
		links.push($$('a', {className: 'pip_bg', href: projects[i].link, target: '_blank', title: projects[i].name, innerHTML: projects[i].name}, {backgroundPosition: '-264px ' + (-16 * i) + 'px'}));
	links.push($$('a', {className: 'pip_qip', href: '//pip.qip.ru/', innerHTML: ''}));
	pip.popup = $$('div', {className  : 'pip_popup pip_popup_hidden pip_popup_' + popup}, null, links);

	var handlers = {
		pip_button : pip.button,
		pip_popup  : pip.popup,
		onmouseover: function(){this.showPopup(true)},
		onmouseout : function(){var _this = this; this.showPopup.pip_timeout = setTimeout(function(){_this.showPopup.call(_this)}, 1000)},
		showPopup  : function(show)
		{
			('pip_timeout' in arguments.callee) && clearTimeout(arguments.callee.pip_timeout);
			var popup = this.pip_popup, className = 'pip_popup_hidden';
			popup.className = (!show && (' ' + popup.className + ' ').indexOf(' ' + className + ' ') == -1)
				? (popup.className + ' ' + className)
				: (' ' + popup.className + ' ').replace(' ' + className + ' ', ' ').slice(1, -1);
		}
	};
	for(var name in handlers)
		pip.hover[name] = pip.popup[name] = handlers[name];

	thisScript.parentNode.insertBefore($$('div', {className: 'pip_container pip_type' + type}, null, [pip.button, pip.popup]), thisScript);
	thisScript.parentNode.removeChild(thisScript);
})();
